/*
Provides input producing numbers between set ranges.  Uses clock time elapsed since power up as srand.  Prints occurrences
and percentages of numbers selected.
J. Hearon 5/22/1990
J. Hearon 9/1/2011
*/

#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include <time.h>
#include <math.h>

int randRange_beta(int n)
{
    int top = ((((RAND_MAX-n)+1)/n)*n-1)+n;
    int r;
    do
    {
        r = rand();
    }
    while (r>top);
    return r%n;
}

int *betainput(int *betareturnarray)
{
    int f,h,l,m,n,t,x; //q, y;
    float ea, eb, a, b, d;
    double r, y1,y2, e, Beta;
    int rand(void);
    int *s = betareturnarray;
    struct timeval  t1;

    printf("\t\t\t  BETA DISTRIBUTION\n");
    printf("\t\t\t***** PITCHES *******");
    printf("\n");

//***************************************
//********  USER INTERFACE **************
//***************************************
first:
    s=(int*)calloc(1000,sizeof(int));/*pointer 's' is allocated 1000 integers and treated like an array */

    printf("\n");
    printf("Enter two numbers between 0..1 (a,b): ");
    scanf("%f,%f",&a,&b);
    ea=(double)1/(double)a;
    eb=(double)1/(double)b;

    printf("\n");
    printf("How many pitches? (500 MAX):");
    scanf("%d",&t);

    d=0;/* sets value of 'd' initially to 0 */
start:
    printf("\nEnter lowest midi note value for a pitch:");
    scanf("%d", &l);
    printf("\nEnter highest midi note value for a pitch:");
    scanf("%d", &h);
    printf("\n");
    if(h-1<=1) /*loop placed here as a precaution*/
    {
        goto start;
    }
    h=h+1;/* highest no. gets plus one */

//***************************************
//********  MAIN BETA LOOP **************
//***************************************
    for (m=1; m<=t; m++)
    {
        for (x=1; x<=10000; x++)
        {
next:

            gettimeofday(&t1, NULL);
            srand(t1.tv_usec * t1.tv_sec);

            r = ((double)rand()/((double)(RAND_MAX)+(double)(1))); /*scales value of 'r' to 0..1 */
            r = r + randRange_beta(2); //makes 'top' of the range 1.  Thus 0 > r < 2.
            //adjust top when RAND_MAX will not allow random selections
            //in the algorithms below.
            //printf(" %4.6f ", r);//DEBUG

            y1=pow(r,ea);
            y2=pow(r,eb);
            e=y1+y2;
            if(e<=1)
            {
                goto step2;
            }
        }//ends x loop
step2:

        Beta=(double)y1/(double)e;
f=(int)(Beta*(h+l-l)+1); //highest + lowest  minus lowest
        if(f<l || f>h-1)  /*avoid out of bounds nums */
        {
            goto next;
        }
        s[m]=f;
    } //ends m loop

    printf("\n...from beta.cpp\n");
    for (m=1; m<=t; m++)
    {
        printf("%4d",s[m]);/*prints numbers */
    }
    printf("\n\n");


//****************************************
//********  User Switch to Try Again *****
//****************************************
    printf("\ntry again? 1 for yes, 2 for no: ");
    scanf("%d", &n);
    switch (n)
    {
        //case 1: goto start;
    case 1:
        free(s);
        goto first;
        break;
    case 2:
        printf("\nbye");
        break;
    }//ends switch
    printf("\n");

    /* //switch with statistical module
       printf("\n");
       printf("\nTry again? (y)es, (q)uit, or (s)tats: ");
       while (getchar()!='\n');
       scanf("%c", &c);
       switch(c)
       {
       case 'y':
           free((int*)s);
           goto first;

       case 'q':
           goto last;
       case 's':
           break;
       }

       h=h-1;
       printf("\n");
       printf("\nNumbers: Occurrences:  %% of Total:");
    //for (y=1;y<=h;y++){
    //printf("\n%2d%14d%17.1f%%",y,s[y],((double)s[y]/(double)t)*100);
    //printf("\n%2d%14d%17.1f%%",y,s[y],(100/(double)t));
    //}

       y = 1;  //note problem passing to cscore2
       do
       {
           printf("\n%2d%14d%17.1f%%",y,s[y],(100/(double)t));
           y++;
           //} while (arrayindex<numrhys+1);
       }
       while (s[y]>0.00001);
       printf("\n\n");


    last:
       printf("\nbye");
       */

    return s;

} //ends betainput


